
#include <stdio.h>
#include <dlfcn.h>

#define MY_LIBRARY "./library.so"
#define MY_SYMBOL "print_int"

int main(void)
{
    /* library descriptor */
    void *lib;

    /* pointeur sur fonction prenant un int et retournant void */
    void (*fonction) (int);

    /* open plugin */
    lib = dlopen(MY_LIBRARY, RTLD_NOW);
    if( lib == NULL )
    {
        fprintf(stderr, "couldn't open " MY_LIBRARY " (%s)\n", dlerror());
        return -1;
    }

    /* load symbol */
    fonction = dlsym(lib, MY_SYMBOL);
    if( fonction == NULL )
    {
        fprintf(stderr, "couldn't load " MY_SYMBOL " (%s)\n", dlerror());
        dlclose(lib);
        return -1;
    }

    /* call symbol */
    fonction(12);

    /* unload plugin */
    dlclose(lib);

    /* exit */
    return 0;
}

